# SoVRMLVertexShape Class Reference

`#include <Inventor/VRMLnodes/SoVRMLVertexShape.h>`

Inheritance diagram for SoVRMLVertexShape:

List of all members.

## Detailed Description

The SoVRMLVertexShape class is a superclass for vertex based shapes.

## Public Types

enum | Binding { OVERALL = SoMaterialBindingElement::OVERALL, PER_PART = SoMaterialBindingElement::PER_PART, PER_PART_INDEXED = SoMaterialBindingElement::PER_PART_INDEXED, PER_FACE = SoMaterialBindingElement::PER_FACE, PER_FACE_INDEXED = SoMaterialBindingElement::PER_FACE_INDEXED, PER_VERTEX = SoMaterialBindingElement::PER_VERTEX, PER_VERTEX_INDEXED = SoMaterialBindingElement::PER_VERTEX_INDEXED }

## Public Member Functions

virtual SbBool | generateDefaultNormals (SoState *s, SoNormalBundle *nb)
virtual SbBool | generateDefaultNormals (SoState *s, SoNormalCache *nc)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | pick (SoPickAction *action)
virtual void | notify (SoNotList *list)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFNode | coord
SoSFNode | texCoord
SoSFNode | normal
SoSFNode | color
SoSFBool | colorPerVertex
SoSFBool | normalPerVertex

## Protected Member Functions

| SoVRMLVertexShape (void)
virtual | ~SoVRMLVertexShape ()
virtual SbBool | shouldGLRender (SoGLRenderAction *action)
void | setNormalCache (SoState *s, int numNormals, SbVec3f *normals)
SoNormalCache * | getNormalCache (void) const
SoNormalCache * | generateAndReadLockNormalCache (SoState *const state)
void | getVertexData (SoState *state, const SoCoordinateElement *&coords, const SbVec3f *&normals, const SbBool neednormals)
void | readLockNormalCache (void)
void | readUnlockNormalCache (void)

## Constructor & Destructor Documentation

SoVRMLVertexShape::SoVRMLVertexShape | ( | void |  | ) | `[protected]`

| Constructor.

SoVRMLVertexShape::~SoVRMLVertexShape | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLVertexShape::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLGeometry. Reimplemented in SoVRMLIndexedFaceSet, and SoVRMLIndexedShape.

SbBool SoVRMLVertexShape::generateDefaultNormals | ( | SoState * | s,
|  | SoNormalBundle * | nb
| ) | `[virtual]`

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Subclasses should override this method to generate default normals using the SoNormalBundle class. `TRUE` should be returned if normals were generated, `FALSE` otherwise.

Default method returns `FALSE`.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented in SoVRMLIndexedFaceSet.

SbBool SoVRMLVertexShape::generateDefaultNormals | ( | SoState * | s,
|  | SoNormalCache * | nc
| ) | `[virtual]`

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Subclasses should override this method to generate default normals using the SoNormalCache class. This is more effective than using SoNormalGenerator. Return `TRUE` if normals were generated, `FALSE` otherwise.

Default method just returns `FALSE`.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented in SoVRMLIndexedFaceSet.

void SoVRMLVertexShape::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoVRMLVertexShape::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape. Reimplemented in SoVRMLIndexedFaceSet.

void SoVRMLVertexShape::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoShape.

void SoVRMLVertexShape::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoShape.

void SoVRMLVertexShape::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode.

void SoVRMLVertexShape::notify | ( | SoNotList * | list | ) | `[virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoVRMLGeometry. Reimplemented in SoVRMLIndexedShape.

SbBool SoVRMLVertexShape::shouldGLRender | ( | SoGLRenderAction * | action | ) | `[protected, virtual]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Reimplemented from SoVRMLGeometry.

SoNormalCache * SoVRMLVertexShape::generateAndReadLockNormalCache | ( | SoState *const | state | ) | `[protected]`

Convenience method that can be used by subclasses to return or create a normal cache. If the current cache is not valid, it takes care of unrefing the old cache and pushing and popping the state to create element dependencies when creating the new cache.

When returning from this method, the normal cache will be read locked, and the caller should call readUnlockNormalCache() when the normals in the cache is no longer needed.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

void SoVRMLVertexShape::getVertexData | ( | SoState * | state,
|  | const SoCoordinateElement *& | coords,
|  | const SbVec3f *& | normals,
|  | const SbBool | neednormals
| ) | `[protected]`

| Convenience method that returns the current coordinate and normal element. This method is not part of the OIV API.

void SoVRMLVertexShape::readLockNormalCache | ( | void |  | ) | `[protected]`

Read lock the normal cache. This method should be called before fetching the normal cache (using getNormalCache()). When the cached normals are no longer needed, readUnlockNormalCache() must be called.

It is also possible to use generateAndReadLockNormalCache().

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

See also:
  readUnlockNormalCache()

Since:
  Coin 2.0

void SoVRMLVertexShape::readUnlockNormalCache | ( | void |  | ) | `[protected]`

Read unlock the normal cache. Should be called when the read-locked cached normals are no longer needed.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

See also:
  readLockNormalCache()

Since:
  Coin 2.0

## Member Data Documentation

SoSFNode SoVRMLVertexShape::coord

| Should contain an SoVRMLCoordinate node.

SoSFNode SoVRMLVertexShape::texCoord

| Can contain an SoVRMLTextureCoordinate node.

SoSFNode SoVRMLVertexShape::normal

| Can contain an SoVRMLNormal node.

SoSFNode SoVRMLVertexShape::color

| Can contain an SoVRMLColor node.

SoSFBool SoVRMLVertexShape::colorPerVertex

| When TRUE, colors are applied per vertex. Default value is TRUE.

SoSFBool SoVRMLVertexShape::normalPerVertex

| When TRUE, normals are applied per vertex. Default value is TRUE.

The documentation for this class was generated from the following files:

- SoVRMLVertexShape.h
- VertexShape.cpp